﻿using Styx.Common;
using Styx.WoWInternals;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Media;

namespace HBDisc
{
    class Hotkeys
    {
        public static bool pauseCR { get; set; }
        public static bool atonementOn = false;
        public static bool changeDPS = false;
        public static bool keysRegistered { get; set; }


        private static Keys keyPause
        {
            get
            {
                return (Keys)Enum.Parse(typeof(Keys), CRSettings.myPrefs.pauseKey);
            }
        }
        private static ModifierKeys modifKeyPause
        {
            get
            {
                return (ModifierKeys)Enum.Parse(typeof(ModifierKeys), CRSettings.myPrefs.modPauseKey);
            }
        }
        private static Keys keyDpsOn
        {
            get
            {
                return (Keys)Enum.Parse(typeof(Keys), CRSettings.myPrefs.dpsOnKey);
            }
        }
        private static ModifierKeys modifKeyDpsOn
        {
            get
            {
                return (ModifierKeys)Enum.Parse(typeof(ModifierKeys), CRSettings.myPrefs.modDpsOnKey);
            }
        }
        private static Keys keyAtonementOn
        {
            get
            {
                return (Keys)Enum.Parse(typeof(Keys), CRSettings.myPrefs.atonementOnKey);
            }
        }
        private static ModifierKeys modifKeyAtonementOn
        {
            get
            {
                return (ModifierKeys)Enum.Parse(typeof(ModifierKeys), CRSettings.myPrefs.modAtonementOnKey);
            }
        }

        public static void registerHotKeys()
        {
            if (keysRegistered) return;

            HotkeysManager.Register("changeDPS", keyDpsOn, modifKeyDpsOn, ret =>
            {
                changeDPS = !changeDPS;
                Lua.DoString(changeDPS ? @"print('DPS Routine: \124cFF15E61C Enabled!')" : @"print('DPS Routine: \124cFFE61515 Disabled!')");
            });

            HotkeysManager.Register("atonementOn", keyAtonementOn, modifKeyAtonementOn, ret =>
            {
                atonementOn = !atonementOn;
                Lua.DoString(atonementOn ? @"print('Atonement: \124cFF15E61C Enabled!')" : @"print('Atonement: \124cFFE61515 Disabled!')");
            });

            HotkeysManager.Register("pauseCR", keyPause, modifKeyPause, ret =>
            {
                pauseCR = !pauseCR;
                Lua.DoString(pauseCR ? @"print('Routine Paused: \124cFF15E61C Enabled!')" : @"print('Routine Paused: \124cFFE61515 Disabled!')");
            });

            keysRegistered = true;
            Logging.Write(" " + "\r\n");
            Logging.Write(Colors.Bisque, "Pause CR Key: " + modifKeyPause + "+ " + keyPause);
            Logging.Write(Colors.Bisque, "Atonement On Key: " + modifKeyAtonementOn + "+ " + keyAtonementOn);
            Logging.Write(Colors.Bisque, "Switch DPS Key: " + modifKeyDpsOn + "+ " + keyDpsOn);
        }
        public static void removeHotkeys()
        {
            if (!keysRegistered) return;

            HotkeysManager.Unregister("pauseCR");
            HotkeysManager.Unregister("atonementOn");
            HotkeysManager.Unregister("changeDPS");

            pauseCR = false;
            atonementOn = false;
            changeDPS = false;
            keysRegistered = false;

            Lua.DoString(@"print('Hotkeys: \124cFFE61515 Removed!')");
            Logging.Write(Colors.OrangeRed, "Hotkeys: Removed!");
        }
    }
}
