﻿using Styx;
using Styx.Common;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

namespace HBDisc
{
    class Items
    {
        public static LocalPlayer Me { get { return StyxWoW.Me; } }

        
        public const uint
       _healingTouch = 5185,
       _healthStone = 5512,
       _healingTonic = 109223,
       _virmensBite = 76089,
       _potionJadeSerpent = 76093,
       _draenicAgilityPotion = 109217,
       _draenicIntellectPotion = 109218,
       _oraliusCrystal = 118922,
       _oraliusCrystalBuff = 118922,
       _insanityCrystal = 86569,
       _insanityCrystalBuff = 127230,
       _alchemyFlask = 75525,
       _alchemyFlaskBuff = 105617,
       _darkmoonFireWater = 124671,
       _potionMoguPower = 114760,
       _draenicStrenghtPotion = 109219,
       ende = 0;

        public static WoWItem HealTonic { get { return Me.BagItems.FirstOrDefault(i => i.Entry == _healingTonic); } }
        public static WoWItem HealthStone { get { return Me.BagItems.FirstOrDefault(i => i.Entry == _healthStone); } }
        public static WoWItem DarkmoonFirewaterItem { get { return Me.BagItems.FirstOrDefault(i => i.Entry == _darkmoonFireWater); } }


        public static void UseTrinkets(bool reqs1, bool reqs2)
        {

            var firstTrinket = StyxWoW.Me.Inventory.Equipped.Trinket1;
            var secondTrinket = StyxWoW.Me.Inventory.Equipped.Trinket2;


            if (firstTrinket != null && reqs1 && CanUseEquippedItem(firstTrinket))
                firstTrinket.Use();


            if (secondTrinket != null && reqs2 && CanUseEquippedItem(secondTrinket))
                secondTrinket.Use();
        }
        private static bool CanUseEquippedItem(WoWItem item)
        {
            string itemSpell = Lua.GetReturnVal<string>("return GetItemSpell(" + item.Entry + ")", 0);
            if (string.IsNullOrEmpty(itemSpell))
                return false;


            return item.Usable && item.Cooldown <= 0;
        }

        public static async Task<bool> UseMyItem(uint item)
        {
            var t = Me.CarriedItems.Where(i => i != null && i.Entry == item).FirstOrDefault();
            t.Use();
            Logging.Write(Colors.Orange, "Using: " + t.Name + " item");
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        public static bool CanUseItem(uint item)
        {
            var t = Me.CarriedItems.Where(i => i != null && i.Entry == item).FirstOrDefault();
            return t != null && t.Usable && t.Cooldown <= 0 ? true : false;
        }
        /* Alchemist Flask
        Crystal of Insanity
        Oralius Whispering Crystal
        None*/

        public static uint wantedBuff
        {
            get
            {
                if (powerbuffs)
                {
                    switch (CRSettings.myPrefs.buffs)
                    {
                        case 0 :
                            return _alchemyFlask;
                        case 1 :
                            return _insanityCrystal;
                        case 2:
                            return _oraliusCrystal;
                        default:
                            return 0;
                    }
                }
                return 0;
            }
        }

        public static bool powerbuffs
        {
            get
            {
                if (CRSettings.myPrefs.buffs == 3) return false;
                if (Me.Auras.Any(a => a.Key.Contains("Flask"))) return false;
                if (CRSettings.myPrefs.buffs == 0 && Me.Auras.Any(a => a.Key.Contains("Enhanced"))) return false;
                if (CRSettings.myPrefs.buffs == 1 && Me.Auras.Any(a => a.Key.Contains("Visions"))) return false;
                if (CRSettings.myPrefs.buffs == 2 && Me.Auras.Any(a => a.Key.Contains("Whispers"))) return false;
                return true;
            }
        }
    }
}
