﻿using System;
using Styx.CommonBot.Routines;
using Styx;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using CommonBehaviors.Actions;
using Styx.CommonBot.Coroutines;
using System.Threading.Tasks;
using Styx.CommonBot;
using Styx.Common;
using System.Linq;
using System.Collections.Generic;
using Styx.WoWInternals;
using System.Windows.Media;
using Styx.Pathing;
using Styx.Common.Helpers;
using Styx.CommonBot.POI;
using System.Diagnostics;

namespace HBDisc
{
    public class Main : CombatRoutine
    {
        public override string Name { get { return "Discipline Priest by Pasterke"; } }
        public override WoWClass Class { get { return WoWClass.Priest; } }
        public static LocalPlayer Me { get { return StyxWoW.Me; } }

        public override Composite CombatBehavior { get { return new ActionRunCoroutine(ctx => rotationSelector()); } }
        public override Composite PullBuffBehavior { get { return new ActionRunCoroutine(ctx => PullRotation()); } }
        public override Composite RestBehavior { get { return new ActionRunCoroutine(ctx => restBehavior()); } }
        public override Composite CombatBuffBehavior { get { return new ActionRunCoroutine(ctx => combatBuffs()); } }
        public override Composite PreCombatBuffBehavior { get { return new ActionRunCoroutine(ctx => preCombatBuffs()); } }

        public static bool OnHold { get { return Hotkeys.pauseCR; } }
        public static int LastSpellCast { get; set; }
        public static bool HaveGlyphHolyFire = false;
        public static string usedBot { get { return BotManager.Current.Name.ToUpper(); } }

        public override void Initialize()
        {
            Hotkeys.registerHotKeys();
        }

        public override void ShutDown()
        {
            Hotkeys.removeHotkeys();
        }

        public override void Pulse()
        {
            if (OnHold) return;



            if (BotPoi.Current.Type == PoiType.None && LootTargeting.Instance.FirstObject != null)
                SetLootPoi(LootTargeting.Instance.FirstObject);

            if (Me.GroupInfo.GroupSize == 0 && Me.IsDead)
            {
                Lua.DoString(string.Format("RunMacroText(\"{0}\")", "/script RepopMe()"));
                return;
            }
        }
        static void SetLootPoi(WoWObject lootObj)
        {
            if (BotPoi.Current.Type != PoiType.None || lootObj == null || !lootObj.IsValid) return;

            if (lootObj is WoWGameObject)
            {
                BotPoi.Current = new BotPoi(lootObj, PoiType.Harvest);
            }
            else
            {
                var unit = lootObj as WoWUnit;
                if (unit != null)
                {
                    if (unit.CanLoot)
                        BotPoi.Current = new BotPoi(lootObj, PoiType.Loot);
                    else if (unit.CanSkin)
                        BotPoi.Current = new BotPoi(lootObj, PoiType.Skin);
                }
            }
        }
        public static async Task<bool> rotationSelector()
        {
            if ((Me.Level < 10 || Me.Specialization == WoWSpec.None) && await dpsRotation()) return true;
            if (Me.Specialization == WoWSpec.PriestDiscipline && (!Party.MeIsInParty || Hotkeys.changeDPS) && await dpsRotation()) return true;
            if (Me.Specialization == WoWSpec.PriestDiscipline && Party.MeIsInParty && !Hotkeys.changeDPS && await HealingRotation()) return true;
            return false;
        }

        public override bool WantButton { get { return true; } }
        public override void OnButtonPress()
        {
            new MainForm().Show();
        }

        public static async Task<bool> restBehavior()
        {
            if (OnHold) return false;
            if (Canbuff && Me.ManaPercent <= 60) await EatDrink();
            if (Me.HealthPercent <= 75 && CanUseFlashHeal()) await CastOnSelf(FlashHeal);

            await CommonCoroutines.SleepForLagDuration();
            return false;
        }

        public static bool CanBuffEat()
        {
            if (OnHold) return false;
            return !Me.Mounted && !Me.IsDead && !Me.IsGhost && !Me.IsOnTransport && !Me.OnTaxi;
        }

        public static async Task<bool> EatDrink()
        {
            if (OnHold) return false;
            
            Styx.CommonBot.Rest.Feed();
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        public static async Task<bool> preCombatBuffs()
        {
            if (OnHold) return false;
            if (Canbuff && needFortitude()) await CastOnSelf(PowerWordFortitude);
            if (Party.MeIsInParty && Canbuff && pwsTank != null) await CastSpellOn(PowerWordShield, pwsTank);
            if (Canbuff && Items.wantedBuff != 0 && Items.CanUseItem(Items.wantedBuff)) await Items.UseMyItem(Items.wantedBuff);
            if (Canbuff && CRSettings.myPrefs.darkmoonFirewater 
                && usedBot.Contains("GATHER") 
                && !Me.Auras.Any(a => a.Key.Contains("Firewater") 
                && Items.CanUseItem(Items._darkmoonFireWater))) await Items.UseMyItem(Items._darkmoonFireWater);

            await CommonCoroutines.SleepForLagDuration();
            return false;
        }

        public static async Task<bool> combatBuffs()
        {
            if (OnHold) return false;
            if (needFortitude()) await CastOnSelf(PowerWordFortitude);
            if (Canbuff && Me.HealthPercent <= CRSettings.myPrefs.healingtonic && Items.CanUseItem(Items._healingTonic) && await Items.UseMyItem(Items._healingTonic)) return true;
            if (Canbuff && Me.HealthPercent <= CRSettings.myPrefs.healthstone && Items.CanUseItem(Items._healthStone) && await Items.UseMyItem(Items._healthStone)) return true;
            if (Canbuff && Me.HealthPercent <= 95 && needPWS()) await CastOnSelf(PowerWordShield);
            if (Canbuff && Me.HealthPercent <= 75 && buffExists(PowerWordShield, Me) && CanUseFlashHeal()) await CastOnSelf(FlashHeal);
            if (Canbuff && Me.HealthPercent <= 45 && CanUseFlashHeal()) await CastOnSelf(FlashHeal);
            if (Canbuff && Me.Race == WoWRace.Draenei && Me.HealthPercent <= CRSettings.myPrefs.naaru && !spellOnCooldown(GiftOfTheNaaru) && LastSpellCast != GiftOfTheNaaru) await CastOnSelf(GiftOfTheNaaru);
            if (CanUseDesperatePrayer() && Me.HealthPercent <= CRSettings.myPrefs.desperate) await CastOnSelf(DesperatePrayer);
            if (Canbuff && !Me.HasAura(FearWard) && !spellOnCooldown(FearWard) && LastSpellCast != FearWard && SpellManager.CanCast(FearWard)) await CastOnSelf(FearWard);

            await CommonCoroutines.SleepForLagDuration();
            return false;
        }

        public static async Task<bool> PullRotation()
        {
            if (OnHold) return false;
            if (gotTarget && Me.CurrentTarget.Distance <= dpsRange) { Navigator.PlayerMover.MoveStop();}
            if (gotTarget && !Me.IsSafelyFacing(Me.CurrentTarget)) { Me.CurrentTarget.Face(); }
            if (gotTarget && needSWP()) await CastSpell(ShadowWordPain);
            if (gotTarget && needSmite()) await CastSpell(Smite);

            if (gotTarget && Me.CurrentTarget.Distance > dpsRange) { Navigator.MoveTo(Me.CurrentTarget.Location); }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }

        public static async Task<bool> dpsRotation()
        {
            if (OnHold) return false;
            if (Me.Mounted) return false;
            if (Me.IsCasting || Me.IsChanneling) return false;
            if (Me.CurrentTarget != null && Me.CurrentTarget.IsDead) Me.ClearTarget();
            if (gotTarget && Movement.AllowMovement() && Me.CurrentTarget.Distance <= dpsRange) { Navigator.PlayerMover.MoveStop();}
            if (gotTarget && Movement.AllowMovement() && !Me.IsSafelyFacing(Me.CurrentTarget)) { Me.CurrentTarget.Face();}

            if (gotTarget && IsOverlayed(Archangel) && !buffExists(Archangel, Me) && !spellOnCooldown(Archangel)) await CastSpell(Archangel);
            if (gotTarget && CanUsePowerInfusion() && Me.CurrentTarget.MaxHealth > Me.MaxHealth * 2 && buffExists(Archangel, Me)) await CastSpell(PowerInfusion);
            if (gotTarget && CanUseShadowfiend() && Me.CurrentTarget.MaxHealth > Me.MaxHealth * 2) await CastSpellOn(Shadowfiend, Me.CurrentTarget);
            
            if (SpellManager.HasSpell(ShadowWordPain)
                && Units.swpTarget != null 
                && SpellManager.CanCast(ShadowWordPain)) await CastSpellOn(ShadowWordPain, Units.swpTarget);
            

            if (gotTarget && needSolace()) await CastSpell(PowerWordSolace);
            if (gotTarget && needHolyFire()) await CastSpell(HolyFire);
            if (gotTarget && needPenance()) await CastSpell(Penance);
            //if (gotTarget && Units.addCount(Me.CurrentTarget, 40) >= 5) await CastSpellOn(MindSear, Me.CurrentTarget);
            if (gotTarget && needSmite()) await CastSpell(Smite);

            if (gotTarget && Movement.AllowMovement() && Me.CurrentTarget.Distance > dpsRange) { Navigator.MoveTo(Me.CurrentTarget.Location); }
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        public static int flashPercent { get { return Me.GroupInfo.GroupSize < 6 ? CRSettings.myPrefs.flashHealP : CRSettings.myPrefs.flashHealR; } }
        public static int pwsPercent { get { return Me.GroupInfo.GroupSize < 6 ? CRSettings.myPrefs.pwsP : CRSettings.myPrefs.pwsR; } }
        public static int penancePercent { get { return Me.GroupInfo.GroupSize < 6 ? CRSettings.myPrefs.penanceP : CRSettings.myPrefs.penanceR; } }
        public static int pomPercent { get { return Me.GroupInfo.GroupSize < 6 ? CRSettings.myPrefs.pomP : CRSettings.myPrefs.pomR; } }
        public static int healPercent { get { return Me.GroupInfo.GroupSize < 6 ? CRSettings.myPrefs.healP : CRSettings.myPrefs.healR; } }
        public static int pohPercent { get { return Me.GroupInfo.GroupSize < 6 ? CRSettings.myPrefs.pohP : CRSettings.myPrefs.pohR; } }
        public static int cascadePercent { get { return Me.GroupInfo.GroupSize < 6 ? CRSettings.myPrefs.cascadeP : CRSettings.myPrefs.cascadeR; } }
        public static int haloPercent { get { return Me.GroupInfo.GroupSize < 6 ? CRSettings.myPrefs.haloP : CRSettings.myPrefs.haloR; } }
        public static int pohPlayers { get { return Me.GroupInfo.GroupSize < 6 ? CRSettings.myPrefs.pohPlayersP : CRSettings.myPrefs.pohPlayersR; } }
        public static int cascadePlayers { get { return Me.GroupInfo.GroupSize < 6 ? CRSettings.myPrefs.cascadePlayersP : CRSettings.myPrefs.cascadePlayersR; } }
        public static int haloPlayers { get { return Me.GroupInfo.GroupSize < 6 ? CRSettings.myPrefs.haloPlayersP : CRSettings.myPrefs.haloPlayersR; } }


        public static async Task<bool> HealingRotation()
        {
            if (OnHold) return false;
            if (Me.Mounted) return false;
            if (gotTarget && Me.CurrentTarget.IsDead) Me.ClearTarget();
            if (gotTarget && debuffExists(PowerWordSolace, Me.CurrentTarget) && !needAtonement()) Me.ClearTarget();
            if (IsOverlayed(Archangel) && !buffExists(Archangel, Me) && !spellOnCooldown(Archangel)) await CastSpell(Archangel);
            if (CanUsePowerInfusion() && buffExists(Archangel, Me)) await CastSpell(PowerInfusion);
            if (!spellOnCooldown(PowerWordSolace) && !Me.IsMoving && !gotTarget) await Units.FindTarget();
            if (gotTarget && needSolace()) await CastSpellOn(PowerWordSolace, Me.CurrentTarget);
            if (pwsTank != null) await CastSpellOn(PowerWordShield, pwsTank);
            if (pwsTarget != null) await CastSpellOn(PowerWordShield, pwsTarget);
            if (penanceTarget != null) await CastSpellOn(Penance, penanceTarget);
            
            if (needCascade() && !Me.IsMoving) await CastSpell(Cascade);
            if (needHalo() && !Me.IsMoving && LastSpellCast != Halo) await CastSpell(Halo);
            if (needPoh() && !Me.IsMoving && LastSpellCast != PrayerofHealing && LastSpellCast != Cascade && LastSpellCast != Halo) await CastSpell(PrayerofHealing);
            if (pomTarget != null && !Me.IsMoving) await CastSpellOn(PrayerofMending, pomTarget);
            if (flashTarget != null && !Me.IsMoving) await CastSpellOn(FlashHeal, flashTarget);
            //if (healTarget != null && !Me.IsMoving) await CastSpellOn(Heal, healTarget);
            if (gotTarget && needAtonement()) await CastSpellOn(Smite, Me.CurrentTarget);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        #region healing
        public static bool needAtonement()
        {
            if (!SpellManager.HasSpell(Atonement)) return false;
            if (Hotkeys.atonementOn) return true;
            return Me.GroupInfo.GroupSize < 6 && CRSettings.myPrefs.needAtonement ? true : false;
        }

        public static WoWUnit pomTarget
        {
            get
            {
                if (!SpellManager.HasSpell(PrayerofMending)) return null;
                if (spellOnCooldown(PrayerofMending)) return null;
                if (LastSpellCast == PrayerofMending) return null;
                if (!SpellManager.CanCast(PrayerofMending)) return null;
                var t = Party.PartyMembers.Where(p => p != null
                    && p.IsAlive
                    && p.InLineOfSight
                    && p.HealthPercent <= pomPercent
                    && !buffExists(PrayerofMending, p)
                    && p.Location.Distance2D(Me.Location) <= 40).OrderBy(p => p.HealthPercent).FirstOrDefault();
                return t != null ? t : null;
            }
        }
        public static WoWUnit healTarget
        {
            get
            {
                if (!SpellManager.HasSpell(Heal)) return null;
                if (spellOnCooldown(Heal)) return null;
                if (LastSpellCast == Heal) return null;
                if (!SpellManager.CanCast(Heal)) return null;
                var t = Party.PartyMembers.Where(p => p != null
                    && p.IsAlive
                    && p.InLineOfSight
                    && p.HealthPercent <= healPercent
                    && p.HealthPercent > flashPercent
                    && p.Location.Distance2D(Me.Location) <= 40).OrderBy(p => p.HealthPercent).FirstOrDefault();
                return t != null ? t : null;
            }
        }
        public static bool needHalo()
        {
            if (!SpellManager.HasSpell(Halo)) return false;
            if (spellOnCooldown(Halo)) return false;
            if (LastSpellCast == Halo) return false;
            if (!SpellManager.CanCast(Halo)) return false;
            var t = Party.PartyMembers.Where(p => p != null
                    && p.IsAlive
                    && p.InLineOfSight
                    && p.HealthPercent <= haloPercent
                    && p.Location.Distance2D(Me.Location) <= 30).OrderBy(p => p.HealthPercent).ToList();
            return t.Count() >= haloPlayers ? true : false;
        }
        public static bool needPoh()
        {
            if (!SpellManager.HasSpell(PrayerofHealing)) return false;
            if (spellOnCooldown(PrayerofHealing)) return false;
            if (LastSpellCast == PrayerofHealing) return false;
            if (!SpellManager.CanCast(PrayerofHealing)) return false;
            var t = Party.PartyMembers.Where(p => p != null
                    && p.IsAlive
                    && p.InLineOfSight
                    && p.HealthPercent <= pohPercent
                    && p.Location.Distance2D(Me.Location) <= 30).OrderBy(p => p.HealthPercent).ToList();
            return t.Count() >= pohPlayers ? true : false;
        }


        public static bool needCascade()
        {
            if (!SpellManager.HasSpell(Cascade)) return false;
            if (spellOnCooldown(Cascade)) return false;
            if (LastSpellCast == Cascade) return false;
            if (!SpellManager.CanCast(Cascade)) return false;
            var t = Party.PartyMembers.Where(p => p != null
                    && p.IsAlive
                    && p.InLineOfSight
                    && p.HealthPercent <= cascadePercent
                    && p.Location.Distance2D(Me.Location) <= 40).OrderBy(p => p.HealthPercent).ToList();
            return t.Count() >= cascadePlayers ? true : false;
        }

        public static WoWUnit pwsTank
        {
            get
            {
                if (!SpellManager.HasSpell(PowerWordShield)) return null;
                if (spellOnCooldown(PowerWordShield)) return null;
                if (LastSpellCast == PowerWordShield) return null;
                if (!SpellManager.CanCast(PowerWordShield)) return null;
                var t = Party.Tanks.Where(p => p != null
                    && p.IsAlive
                    && p.InLineOfSight
                    && !buffExists(weakenedsoul, p)
                    && p.Distance2D <= 40).OrderBy(p => p.HealthPercent).FirstOrDefault();
                return t != null ? t : null;
            }
        }
        public static WoWUnit pwsTarget
        {
            get
            {
                if (!Me.Combat) return null;
                if (!SpellManager.HasSpell(PowerWordShield)) return null;
                if (spellOnCooldown(PowerWordShield)) return null;
                if (LastSpellCast == PowerWordShield) return null;
                if (!SpellManager.CanCast(PowerWordShield)) return null;
                var t = Party.PartyMembers.Where(p => p != null
                    && p.IsAlive
                    && p.InLineOfSight
                    && p.HealthPercent <= pwsPercent
                    && !buffExists(weakenedsoul, p)
                    && p.Distance2D <= 40).OrderBy(p => p.HealthPercent).FirstOrDefault();
                return t != null ? t : null;
            }
        }
        public static WoWUnit penanceTarget
        {
            get
            {
                if (!Me.Combat) return null;
                if (!SpellManager.HasSpell(Penance)) return null;
                if (spellOnCooldown(Penance)) return null;
                if (LastSpellCast == Penance) return null;
                if (!SpellManager.CanCast(Penance)) return null;
                var t = Party.PartyMembers.Where(p => p != null
                    && p.IsAlive
                    && p.InLineOfSight
                    && p.HealthPercent <= penancePercent
                    && p.Distance2D <= 40).OrderBy(p => p.HealthPercent).FirstOrDefault();
                return t != null ? t : null;
            }
        }
        public static WoWUnit flashTarget
        {
            get
            {
                if (!Me.Combat) return null;
                if (!CanUseFlashHeal()) return null;
                var t = Party.PartyMembers.Where(p => p != null
                    && p.IsAlive
                    && p.InLineOfSight
                    && p.HealthPercent <= flashPercent
                    && p.Distance2D <= 40).OrderBy(p => p.HealthPercent).FirstOrDefault();
                return t != null ? t : null;
            }
        }
        #endregion

        #region shadowfiend
        public static bool CanUseShadowfiend()
        {
            if (!Canbuff) return false;
            if (!SpellManager.HasSpell(Shadowfiend)) return false;
            if (LastSpellCast == Shadowfiend) return false;
            if (spellOnCooldown(Shadowfiend)) return false;
            if (!SpellManager.CanCast(Shadowfiend)) return false;
            return true;
        }
        #endregion

        #region powerinfusion
        public static bool CanUsePowerInfusion()
        {
            if (!Canbuff) return false;
            if (!SpellManager.HasSpell(PowerInfusion)) return false;
            if (LastSpellCast == PowerInfusion) return false;
            if (spellOnCooldown(PowerInfusion)) return false;
            if (!SpellManager.CanCast(PowerInfusion)) return false;
            if (Party.MeIsInParty)
            {
                var t = Party.PartyMembers.Where(p => p != null
                        && p.IsAlive
                        && p.InLineOfSight
                        && p.HealthPercent <= 65
                        && p.Distance2D <= 40).OrderBy(p => p.HealthPercent).ToList();
                if (Me.GroupInfo.GroupSize < 6 && t.Count() >= 3) return true;
                if (Me.GroupInfo.GroupSize > 5 && t.Count() >= 5) return true;
                return false;
            }
            return true;
        }
        #endregion

        #region needDesperatePrayer
        public static bool CanUseDesperatePrayer()
        {
            if (!Canbuff) return false;
            if (!SpellManager.HasSpell(DesperatePrayer)) return false;
            if (LastSpellCast == DesperatePrayer) return false;
            if (spellOnCooldown(DesperatePrayer)) return false;
            if (!SpellManager.CanCast(DesperatePrayer)) return false;
            return true;
        }
        #endregion

        #region needFlashHeal
        public static bool CanUseFlashHeal()
        {
            if (!Canbuff) return false;
            if (!SpellManager.HasSpell(FlashHeal)) return false;
            if (!SpellManager.CanCast(FlashHeal)) return false;
            return true;
        }
        #endregion

        #region penance
        public static bool needPenance()
        {
            if (!Canbuff) return false;
            if (!SpellManager.HasSpell(Penance)) return false;
            if (LastSpellCast == Penance) return false;
            if (Me.CurrentTarget.Distance > 39) return false;
            if (!SpellManager.CanCast(Penance)) return false;
            return true;
        }
        #endregion

        #region pws
        public static bool needPWS()
        {
            if (!Canbuff) return false;
            if (LastSpellCast == PowerWordShield) return false;
            if (!SpellManager.HasSpell(PowerWordShield)) return false;
            if (buffExists(weakenedsoul, Me)) return false;
            if (!SpellManager.CanCast(PowerWordShield)) return false;
            return true;
        }
        #endregion

        #region holy fire
        public static bool needHolyFire()
        {
            if (!Canbuff) return false;
            if (Me.CurrentTarget.Distance > dpsRange) return false;
            if (LastSpellCast == HolyFire) return false;
            if (!SpellManager.HasSpell(HolyFire)) return false;
            if (!SpellManager.CanCast(HolyFire)) return false;
            return true;
        }
        #endregion

        #region fortitude
        public static bool needFortitude()
        {
            if (Party.MeIsInParty) return false;
            if (!Canbuff) return false;
            if (LastSpellCast == PowerWordFortitude) return false;
            if (!SpellManager.HasSpell(PowerWordFortitude)) return false;
            if (buffExists(PowerWordFortitude, Me)) return false;
            if (!SpellManager.CanCast(PowerWordFortitude)) return false;
            return true;
        }
        #endregion

        #region solace
        public static bool needSolace()
        {
            if (!Canbuff) return false;
            if (Me.CurrentTarget.Distance > dpsRange) return false;
            if (LastSpellCast == PowerWordSolace) return false;
            if (!SpellManager.HasSpell(PowerWordSolace)) return false;
            if (!SpellManager.CanCast(PowerWordSolace)) return false;
            return true;
        }
        #endregion

        #region swpain
        public static bool needSWP()
        {
            if (!Canbuff) return false;
            if (Me.CurrentTarget.Distance > 39) return false;
            if (!SpellManager.HasSpell(ShadowWordPain)) return false;
            if (debuffExists(ShadowWordPain, Me.CurrentTarget)) return false;
            if (!SpellManager.CanCast(ShadowWordPain)) return false;
            return true;
        }
        #endregion

        #region smite
        public static bool needSmite()
        {
            if (Me.CurrentTarget.Distance > dpsRange -1) return false;
            if (!SpellManager.CanCast(Smite)) return false;
            return true;
        }
        #endregion

        #region have target
        public static bool gotTarget { get { return StyxWoW.Me.CurrentTarget != null && Me.CurrentTarget.IsAlive && Me.CurrentTarget.Attackable; } }
        #endregion

        #region can buff
        public static bool Canbuff
        {
            get
            {
                return !Me.Mounted && !Me.IsDead && !Me.IsGhost && !Me.InVehicle && !Me.OnTaxi && !Me.IsOnTransport;
            }
        }
        #endregion

        #region spellcasting
        public static async Task<bool> CastOnSelf(int spell)
        {
            try
            {
                SpellManager.Cast(spell, Me);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            catch (Exception e) { Logging.WriteDiagnostic("CastOnSelf: " + spell + " " + e.ToString()); }
            return false;
        }

        public static async Task<bool> CastSpell(int spell)
        {
            try
            {
                SpellManager.Cast(spell);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            catch (Exception e) { Logging.WriteDiagnostic("CastSpell: " + spell + " " + e.ToString()); }
            return false;
        }

        public static async Task<bool> CastSpellOn(int spell, WoWUnit unit)
        {
            try
            {
                SpellManager.Cast(spell, unit);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            catch (Exception e) { Logging.WriteDiagnostic("CastSpell: " + spell + " " + e.ToString()); }
            return false;
        }

        public static async Task<bool> CastOnGround(int spell, WoWPoint pos)
        {
            try
            {
                SpellManager.Cast(spell);
                SpellManager.ClickRemoteLocation(pos);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            catch (Exception e) { Logging.WriteDiagnostic("CastOnGround: " + spell + " " + e.ToString()); }
            return false;
        }
        #endregion

        #region spells
        
        string pwFortitude = "Power Word: Fortitude";
        string pwSolace = "Power Word: Solace";
        string pwShield = "Power Word: Shield";
        string archangel = "Archangel";
        string penance = "Penance";
        string PoM = "Prayer of Mending";
        string holyFire = "Holy Fire";
        string painSuppression = "Pain Suppression";
        string swPain = "Shadow Word: Pain";
        string smite = "Smite";
        string PoH = "Prayer of Healing";
        string heal = "Heal";
        string holyNova = "Holy Nova";
        string flashHeal = "Flash Heal";
        string purify = "Purify";
        string fade = "Fade";
        string dispelMagic = "Dispel Magic";
        string silence = "Silence";
        string fearWard = "Fear Ward";
        string pwBarrier = "Power Word: Barrier";
        string massDispel = "Mass Dispel";
        string cascade = "Cascade";
        string halo = "Halo";
        string desperatePrayer = "Desperate Prayer";
        string mindSear = "Mind Sear";
        string mindbender = "Mindbender";
        string shadowFiend = "Shadowfiend";
        string powerInfusion = "Power Infusion";

        public const int
            //Disc
        ArcaneTorrent = 28730,
        Archangel = 81700,
        Atonement = 81749,
        AutoAttack = 6603,
        BodyandSoul = 64129,
        Cascade = 121135,
        DesperatePrayer = 19236,
        DispelMagic = 528,
        Evangelism = 81662,
        Fade = 586,
        FearWard = 6346,
        FlashHeal = 2061,
        FocusedWill = 045243,
        GiftOfTheNaaru = 28880,
        Halo = 120517,
        Heal = 2060,
        HolyFire = 14914,
        HolyNova = 132157,
        Levitate = 1706,
        MassDispel = 032375,
        MassResurrection = 83968,
        MindSear = 48045,
        MindVision = 2096,
        PainSuppression = 33206,
        Penance = 47540,
        PowerWordBarrier = 62618,
        PowerWordFortitude = 21562,
        PowerInfusion = 10060,
        PowerWordShield = 17,
        PowerWordSolace = 129250,
        PrayerofHealing = 596,
        PrayerofMending = 33076,
        Purify = 527,
        Resurrection = 2006,
        ShackleUndead = 9484,
        ShadowWordPain = 589,
        Shadowfiend = 34433,
        Shoot = 5019,
        Silence = 15487,
        Smite = 585,
        TwistofFate = 109142,
        Mindbender = 123040,
        PsychicScream = 8122,
        weakenedsoul = 6788,
        MindFlay = 0,
        THE_END = 0;
        #endregion

        #region overlayed
        public static bool IsOverlayed(int spellID)
        {
            return Lua.GetReturnVal<bool>("return IsSpellOverlayed(" + spellID + ")", 0);
        }
        #endregion

        #region Buff Checks

        public static bool buffExists(int Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraById(Buff);
                if (Results != null)
                    return true;
            }
            return false;
        }

        public static double buffTimeLeft(int Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraById(Buff);
                if (Results != null)
                {
                    if (Results.TimeLeft.TotalMilliseconds > 0)
                        return Results.TimeLeft.TotalMilliseconds;
                }
            }
            return 0;
        }

        public static bool buffExists(string Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraByName(Buff);
                if (Results != null)
                    return true;
            }
            return false;
        }

        public static double buffTimeLeft(string Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraByName(Buff);
                if (Results != null)
                {
                    if (Results.TimeLeft.TotalMilliseconds > 0)
                        return Results.TimeLeft.TotalMilliseconds;
                }
            }
            return 0;
        }



        public static uint buffStackCount(int Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraById(Buff);
                if (Results != null)
                    return Results.StackCount;
            }
            return 0;
        }
        public static uint buffStackCount(string Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraByName(Buff);
                if (Results != null)
                    return Results.StackCount;
            }
            return 0;
        }
        #endregion

        #region Cooldown Checks
        private static Dictionary<WoWSpell, long> Cooldowns = new Dictionary<WoWSpell, long>();
        public static TimeSpan cooldownLeft(int Spell)
        {
            SpellFindResults Results;
            if (SpellManager.FindSpell(Spell, out Results))
            {
                WoWSpell Result = Results.Override ?? Results.Original;
                if (Cooldowns.TryGetValue(Result, out lastUsed))
                {
                    if (DateTime.Now.Ticks < lastUsed)
                        return Result.CooldownTimeLeft;
                    return TimeSpan.MaxValue;
                }
            }
            return TimeSpan.MaxValue;
        }
        public static TimeSpan cooldownLeft(string Spell)
        {
            SpellFindResults Results;
            if (SpellManager.FindSpell(Spell, out Results))
            {
                WoWSpell Result = Results.Override ?? Results.Original;
                if (Cooldowns.TryGetValue(Result, out lastUsed))
                {
                    if (DateTime.Now.Ticks < lastUsed)
                        return Result.CooldownTimeLeft;
                    return TimeSpan.MaxValue;
                }
            }
            return TimeSpan.MaxValue;
        }
        private static long lastUsed;
        public static int lastCast;
        public static bool onCooldown(int Spell)
        {
            SpellFindResults Results;
            if (SpellManager.FindSpell(Spell, out Results))
            {
                WoWSpell Result = Results.Override ?? Results.Original;
                if (Cooldowns.TryGetValue(Result, out lastUsed))
                {
                    if (DateTime.Now.Ticks < lastUsed)
                        return Result.Cooldown;
                    return false;
                }
            }
            return false;
        }
        public static bool onCooldown(string Spell)
        {
            SpellFindResults Results;
            if (SpellManager.FindSpell(Spell, out Results))
            {
                WoWSpell Result = Results.Override ?? Results.Original;
                if (Cooldowns.TryGetValue(Result, out lastUsed))
                {
                    if (DateTime.Now.Ticks < lastUsed)
                        return Result.Cooldown;
                    return false;
                }
            }
            return false;
        }
        public static TimeSpan spellCooldownLeft(int Spell, bool useTracker = false)
        {
            if (useTracker)
                return cooldownLeft(Spell);
            SpellFindResults results;
            if (SpellManager.FindSpell(Spell, out results))
            {
                if (results.Override != null)
                    return results.Override.CooldownTimeLeft;
                return results.Override.CooldownTimeLeft;
            }
            return TimeSpan.MaxValue;
        }
        public static TimeSpan spellCooldownLeft(string Spell, bool useTracker = false)
        {
            if (useTracker)
                return cooldownLeft(Spell);
            SpellFindResults results;
            if (SpellManager.FindSpell(Spell, out results))
            {
                if (results.Override != null)
                    return results.Override.CooldownTimeLeft;
                return results.Override.CooldownTimeLeft;
            }
            return TimeSpan.MaxValue;
        }
        public static bool spellOnCooldown(int Spell, bool useTracker = false)
        {
            if (useTracker)
                return !onCooldown(Spell);
            SpellFindResults results;
            if (SpellManager.FindSpell(Spell, out results))
                return results.Override != null ? results.Override.Cooldown : results.Original.Cooldown;
            return false;
        }
        public static bool spellOnCooldown(string Spell, bool useTracker = false)
        {
            if (useTracker)
                return !onCooldown(Spell);
            SpellFindResults results;
            if (SpellManager.FindSpell(Spell, out results))
                return results.Override != null ? results.Override.Cooldown : results.Original.Cooldown;
            return false;
        }
        #endregion

        #region Debuff Checks

        public static bool debuffExists(int Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a => a.SpellId == Debuff && a.CreatorGuid == Me.Guid);
                if (aura != null)
                {
                    return true;
                }
            }
            return false;
        }

        public static double debuffTimeLeft(int Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a =>
                    a.SpellId == Debuff
                    && a.CreatorGuid == Me.Guid);

                if (aura == null)
                {
                    return 0;
                }
                return aura.TimeLeft.TotalMilliseconds;
            }
            return 0;
        }

        public static uint debuffStackCount(int Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a =>
                    a.SpellId == Debuff
                    && a.CreatorGuid == Me.Guid);

                if (aura == null)
                {
                    return 0;
                }
                return aura.StackCount;
            }
            return 0;
        }
        public static bool debuffExists(string Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a => a.Name == Debuff && a.CreatorGuid == Me.Guid);
                if (aura != null)
                {
                    return true;
                }
            }
            return false;
        }

        public static double debuffTimeLeft(string Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a =>
                    a.Name == Debuff
                    && a.CreatorGuid == Me.Guid);

                if (aura == null)
                {
                    return 0;
                }
                return aura.TimeLeft.TotalMilliseconds;
            }
            return 0;
        }

        public static uint debuffStackCount(string Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a =>
                    a.Name == Debuff
                    && a.CreatorGuid == Me.Guid);

                if (aura == null)
                {
                    return 0;
                }
                return aura.StackCount;
            }
            return 0;
        }
        #endregion

        #region dpsrange
        public static void myGlyphs()
        {
            var t = Me.GetGlyphSockets();
            foreach (var g in t)
            {
                if (g.ToString().Contains("Glyph of Holy Fire")) HaveGlyphHolyFire = true;
                else HaveGlyphHolyFire = false;
            }
        }
        public static float dpsRange
        {
            get
            {
                if (HaveGlyphHolyFire) return 40;
                return 30;
            }
        }
        #endregion























    }














































































}
