﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace HBDisc
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void saveExitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Hotkeys.registerHotKeys();
            CRSettings.myPrefs.Save();
            Close();
        }

        private void numericUpDownFlashP_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.flashHealP = (int)numericUpDownFlashP.Value;
        }

        private void numericUpDownFlashR_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.flashHealR = (int)numericUpDownFlashR.Value;
        }

        private void numericUpDownPenanceP_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.penanceP = (int)numericUpDownPenanceP.Value;
        }

        private void numericUpDownPenanceR_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.penanceR = (int)numericUpDownPenanceR.Value;
        }

        private void numericUpDownPwsP_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.pwsP = (int)numericUpDownPwsP.Value;
        }

        private void numericUpDownPwsR_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.pwsR = (int)numericUpDownPwsR.Value;
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            Hotkeys.keysRegistered = false;
            numericUpDownPwsR.Value = new decimal (CRSettings.myPrefs.pwsR);
            numericUpDownPwsP.Value = new decimal (CRSettings.myPrefs.pwsP);
            numericUpDownPenanceR.Value = new decimal (CRSettings.myPrefs.penanceR);
            numericUpDownPenanceP.Value = new decimal (CRSettings.myPrefs.penanceP);
            numericUpDownFlashR.Value = new decimal (CRSettings.myPrefs.flashHealR);
            numericUpDownFlashP.Value = new decimal (CRSettings.myPrefs.flashHealP);
            numericUpDownDesperatePrayer.Value = new decimal(CRSettings.myPrefs.desperate);
            numericUpDownHealthstone.Value = new decimal(CRSettings.myPrefs.healthstone);
            numericUpDownHealTonic.Value = new decimal(CRSettings.myPrefs.healingtonic);
            numericUpDownNaaru.Value = new decimal(CRSettings.myPrefs.naaru);
            numericUpDownHaloPlayersP.Value = new decimal(CRSettings.myPrefs.haloPlayersP);
            numericUpDownHaloPlayersR.Value = new decimal(CRSettings.myPrefs.haloPlayersR);
            numericUpDownHaloP.Value = new decimal(CRSettings.myPrefs.haloP);
            numericUpDownHaloR.Value = new decimal(CRSettings.myPrefs.haloR);
            numericUpDownCascadeP.Value = new decimal(CRSettings.myPrefs.cascadeP);
            numericUpDownCascadeR.Value = new decimal(CRSettings.myPrefs.cascadeR);
            numericUpDownCascadePlayersP.Value = new decimal(CRSettings.myPrefs.cascadePlayersP);
            numericUpDownCascadePlayersR.Value = new decimal(CRSettings.myPrefs.cascadePlayersR);
            numericUpDownHaloP.Value = new decimal(CRSettings.myPrefs.haloP);
            numericUpDownHaloR.Value = new decimal(CRSettings.myPrefs.haloR);
            numericUpDownHaloPlayersP.Value = new decimal(CRSettings.myPrefs.haloPlayersP);
            numericUpDownHaloPlayersR.Value = new decimal(CRSettings.myPrefs.haloPlayersR);
            numericUpDownPomP.Value = new decimal(CRSettings.myPrefs.pomP);
            numericUpDownPomR.Value = new decimal(CRSettings.myPrefs.pomR);
            numericUpDownPohP.Value = new decimal(CRSettings.myPrefs.pohP);
            numericUpDownPohR.Value = new decimal(CRSettings.myPrefs.pohR);
            numericUpDownPohPlayersP.Value = new decimal(CRSettings.myPrefs.pohPlayersP);
            numericUpDownPohPlayersR.Value = new decimal(CRSettings.myPrefs.pohPlayersR);

            checkBoxMovement.Checked = CRSettings.myPrefs.enableMovement;
            checkBoxDarkmoonFirewater.Checked = CRSettings.myPrefs.darkmoonFirewater;

            comboBoxStrafeRight.SelectedText = CRSettings.myPrefs.straferight;
            comboBoxStrafeLeft.SelectedText = CRSettings.myPrefs.strafeleft;
            comboBoxMoveRight.SelectedText = CRSettings.myPrefs.moveright;
            comboBoxMoveLeft.SelectedText = CRSettings.myPrefs.moveleft;
            comboBoxForwards.SelectedText = CRSettings.myPrefs.moveforwards;
            comboBoxBackwards.SelectedText = CRSettings.myPrefs.movebackward;
            if (CRSettings.myPrefs.needAtonement) { comboBoxAtonement.SelectedText = "True"; } else { comboBoxAtonement.SelectedText = "False"; }
            comboBoxAtonementOnHottie.SelectedText = CRSettings.myPrefs.atonementOnKey;
            comboBoxAtonementOnMod.SelectedText = CRSettings.myPrefs.modAtonementOnKey;
            comboBoxPauseCRHottie.SelectedText = CRSettings.myPrefs.pauseKey;
            comboBoxPauseCRMod.SelectedText = CRSettings.myPrefs.modPauseKey;
            comboBoxSwitchDpsHottie.SelectedText = CRSettings.myPrefs.dpsOnKey;
            comboBoxSwitchDpsMod.SelectedText = CRSettings.myPrefs.modDpsOnKey;
            comboBoxBuffs.SelectedIndex = CRSettings.myPrefs.buffs;
            
        }

        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            Hotkeys.registerHotKeys();
            CRSettings.myPrefs.Save();
        }

        private void numericUpDownDesperatePrayer_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.desperate = (int)numericUpDownDesperatePrayer.Value;
        }

        private void numericUpDownHealTonic_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.healingtonic = (int)numericUpDownHealTonic.Value;
        }

        private void numericUpDownHealthstone_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.healthstone = (int)numericUpDownHealthstone.Value;
        }

        private void numericUpDownNaaru_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.naaru = (int)numericUpDownNaaru.Value;
        }

        private void checkBoxMovement_CheckedChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.enableMovement = checkBoxMovement.Checked;
            CRSettings.myPrefs.enableFacing = checkBoxMovement.Checked;
            CRSettings.myPrefs.enableTargeting = checkBoxMovement.Checked;
        }

        /*W Z E R T A Q S D*/

        private void comboBoxForwards_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.moveforwards = comboBoxForwards.SelectedItem.ToString();
        }

        private void comboBoxBackwards_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.movebackward = comboBoxBackwards.SelectedItem.ToString();
        }

        private void comboBoxMoveLeft_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.moveleft = comboBoxMoveLeft.SelectedItem.ToString();
        }

        private void comboBoxMoveRight_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.moveright = comboBoxMoveRight.SelectedItem.ToString();
        }

        private void comboBoxStrafeLeft_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.strafeleft = comboBoxStrafeLeft.SelectedItem.ToString();
        }

        private void comboBoxStrafeRight_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.straferight = comboBoxStrafeRight.SelectedItem.ToString();
        }

        private void comboBoxAtonement_SelectedIndexChanged(object sender, EventArgs e)
        {
            string at = comboBoxAtonement.SelectedItem.ToString();
            switch (at)
            {
                case "True":
                    CRSettings.myPrefs.needAtonement = true;
                    break;
                case "False":
                    CRSettings.myPrefs.needAtonement = false;
                    break;
                default:
                    CRSettings.myPrefs.needAtonement = false;
                    break;
            }

        }

        private void numericUpDownPomP_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.pomP = (int)numericUpDownPomP.Value;
        }

        private void numericUpDownPomR_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.pomR = (int)numericUpDownPomR.Value;
        }

        private void numericUpDownPohP_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.pohP = (int)numericUpDownPohP.Value;
        }

        private void numericUpDownPohR_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.pohR = (int)numericUpDownPohR.Value;
        }

        private void numericUpDownPohPlayersP_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.pohPlayersP = (int)numericUpDownPohPlayersP.Value;
        }

        private void numericUpDownPohPlayersR_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.pohPlayersR = (int)numericUpDownPohPlayersR.Value;
        }

        private void numericUpDownCascadeP_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.cascadeP = (int)numericUpDownCascadeP.Value;
        }

        private void numericUpDownCascadeR_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.cascadeR = (int)numericUpDownCascadeR.Value;
        }

        private void numericUpDownCascadePlayersP_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.cascadePlayersP = (int)numericUpDownCascadePlayersP.Value;
        }

        private void numericUpDownCascadePlayersR_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.cascadePlayersR = (int)numericUpDownCascadePlayersR.Value;
        }

        private void numericUpDownHaloP_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.haloP = (int)numericUpDownHaloP.Value;
        }

        private void numericUpDownHaloR_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.haloR = (int)numericUpDownHaloR.Value;
        }

        private void numericUpDownHaloPlayersP_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.haloPlayersP = (int)numericUpDownHaloPlayersP.Value;
        }

        private void numericUpDownHaloPlayersR_ValueChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.haloPlayersR = (int)numericUpDownHaloPlayersR.Value;
        }

        private void comboBoxPauseCRMod_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.modPauseKey = comboBoxPauseCRMod.SelectedItem.ToString();
        }

        private void comboBoxPauseCRHottie_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.pauseKey = comboBoxPauseCRHottie.SelectedItem.ToString();
        }

        private void comboBoxSwitchDpsMod_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.modDpsOnKey = comboBoxSwitchDpsMod.SelectedItem.ToString();
        }

        private void comboBoxSwitchDpsHottie_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.dpsOnKey = comboBoxSwitchDpsHottie.SelectedItem.ToString();
        }

        private void comboBoxAtonementOnMod_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.modAtonementOnKey = comboBoxAtonementOnMod.SelectedItem.ToString();
        }

        private void comboBoxAtonementOnHottie_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.atonementOnKey = comboBoxAtonementOnHottie.SelectedItem.ToString();
        }

        private void comboBoxBuffs_SelectedIndexChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.buffs = comboBoxBuffs.SelectedIndex;
        }

        private void checkBoxDarkmoonFirewater_CheckedChanged(object sender, EventArgs e)
        {
            CRSettings.myPrefs.darkmoonFirewater = checkBoxDarkmoonFirewater.Checked;
        }
    }
}
