﻿using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace HBDisc
{
    class Movement
    {
        public static string usedBot { get { return BotManager.Current.Name.ToUpper(); } }
        public static LocalPlayer Me { get { return StyxWoW.Me; } }

        [DllImport("user32.dll")]
        private static extern short GetAsyncKeyState(Keys vKey);

        private static Keys moveForward = (Keys)Enum.Parse(typeof(Keys), CRSettings.myPrefs.moveforwards);
        private static Keys moveBackward = (Keys)Enum.Parse(typeof(Keys), CRSettings.myPrefs.movebackward);
        private static Keys moveLeft = (Keys)Enum.Parse(typeof(Keys), CRSettings.myPrefs.moveleft);
        private static Keys moveRight = (Keys)Enum.Parse(typeof(Keys), CRSettings.myPrefs.moveright);
        private static Keys strafeLeft = (Keys)Enum.Parse(typeof(Keys), CRSettings.myPrefs.strafeleft);
        private static Keys strafeRight = (Keys)Enum.Parse(typeof(Keys), CRSettings.myPrefs.straferight);


        public static bool AllowFacing()
        {
            if ((GetAsyncKeyState(Keys.LButton) != 0
                || GetAsyncKeyState(Keys.RButton) != 0)
                || GetAsyncKeyState(moveForward) != 0
                || GetAsyncKeyState(moveBackward) != 0
                || GetAsyncKeyState(moveLeft) != 0
                || GetAsyncKeyState(moveRight) != 0
                || GetAsyncKeyState(strafeLeft) != 0
                || GetAsyncKeyState(strafeRight) != 0)
            {
                return false;
            }
            if (usedBot.Contains("QUEST") || usedBot.Contains("GRIND") || usedBot.Contains("FISH") || usedBot.Contains("ARCHEO")) return true;
            return CRSettings.myPrefs.enableFacing;
        }

        public static bool AllowMovement()
        {

            if ((GetAsyncKeyState(Keys.LButton) != 0
                || GetAsyncKeyState(Keys.RButton) != 0)
                || GetAsyncKeyState(moveForward) != 0
                || GetAsyncKeyState(moveBackward) != 0
                || GetAsyncKeyState(moveLeft) != 0
                || GetAsyncKeyState(moveRight) != 0
                || GetAsyncKeyState(strafeLeft) != 0
                || GetAsyncKeyState(strafeRight) != 0)
            {
                return false;
            }
            if (usedBot.Contains("QUEST") || usedBot.Contains("GRIND") || usedBot.Contains("FISH") || usedBot.Contains("ARCHEO")) return true;

            return CRSettings.myPrefs.enableMovement;
        }

        public static bool StopMovement()
        {

            if ((GetAsyncKeyState(Keys.LButton) != 0
                || GetAsyncKeyState(Keys.RButton) != 0)
                || GetAsyncKeyState(moveForward) != 0
                || GetAsyncKeyState(moveBackward) != 0
                || GetAsyncKeyState(moveLeft) != 0
                || GetAsyncKeyState(moveRight) != 0
                || GetAsyncKeyState(strafeLeft) != 0
                || GetAsyncKeyState(strafeRight) != 0)
            {
                return false;
            }
            return true;
        }

        public static bool AutoTarget()
        {

            if ((GetAsyncKeyState(Keys.LButton) != 0
                || GetAsyncKeyState(Keys.RButton) != 0)
                || GetAsyncKeyState(moveForward) != 0
                || GetAsyncKeyState(moveBackward) != 0
                || GetAsyncKeyState(moveLeft) != 0
                || GetAsyncKeyState(moveRight) != 0
                || GetAsyncKeyState(strafeLeft) != 0
                || GetAsyncKeyState(strafeRight) != 0)
            {
                return false;
            }
            return CRSettings.myPrefs.enableTargeting;
        }
        public static async Task MoveToRangeTarget(float range)
        {
            if (Me.CurrentTarget == null) return;

            if ((GetAsyncKeyState(Keys.LButton) != 0
                || GetAsyncKeyState(Keys.RButton) != 0)
                || GetAsyncKeyState(moveForward) != 0
                || GetAsyncKeyState(moveBackward) != 0
                || GetAsyncKeyState(moveLeft) != 0
                || GetAsyncKeyState(moveRight) != 0
                || GetAsyncKeyState(strafeLeft) != 0
                || GetAsyncKeyState(strafeRight) != 0)
                try
                {
                    await MoveToTarget(Me.CurrentTarget,
                        () =>
                            Me.CurrentTarget != null
                            && AllowMovement()
                            && (!IsDistanceGood(range) || !Me.CurrentTarget.InLineOfSight));

                    await MoveStop(
                        () =>
                            Me.CurrentTarget != null
                            && AllowMovement()
                            && IsDistanceGood(range)
                            && Me.CurrentTarget.InLineOfSight);
                }
                catch (Exception ex)
                {
                    Logging.Write(string.Format("Exception caught while trying to move: {0}", ex.Message));
                }
        }

        public static bool IsDistanceGood(float range) { return Me.CurrentTarget != null && Me.CurrentTarget.Distance <= range; }

        public static async Task MoveToCombatTarget()
        {
            if (Me.CurrentTarget == null) return;

            if ((GetAsyncKeyState(Keys.LButton) != 0
                || GetAsyncKeyState(Keys.RButton) != 0)
                || GetAsyncKeyState(moveForward) != 0
                || GetAsyncKeyState(moveBackward) != 0
                || GetAsyncKeyState(moveLeft) != 0
                || GetAsyncKeyState(moveRight) != 0
                || GetAsyncKeyState(strafeLeft) != 0
                || GetAsyncKeyState(strafeRight) != 0)
                try
                {
                    await MoveToTarget(Me.CurrentTarget,
                        () =>
                            Me.CurrentTarget != null
                            && AllowMovement()
                            && (!Me.CurrentTarget.IsWithinMeleeRange || !Me.CurrentTarget.InLineOfSight));

                    await MoveStop(
                        () =>
                            Me.CurrentTarget != null
                            && AllowMovement()
                            && Me.CurrentTarget.IsWithinMeleeRange
                            && Me.CurrentTarget.InLineOfSight);
                }
                catch (Exception ex)
                {
                    Logging.Write(string.Format("Exception caught while trying to move: {0}", ex.Message));
                }
        }
        /// <summary>
        /// (Non-Blocking) Attempts to move to the specified target.
        /// </summary>
        /// <returns>Returns true if we are able to move towards the target.</returns>
        public static async Task MoveToTarget(WoWUnit target, Func<bool> conditionCheck = null)
        {
            if (conditionCheck != null && !conditionCheck())
                return;

            if (target == null)
                return;

            if (target.IsDead)
                return;

            await CommonCoroutines.MoveTo(target.Location);
        }

        /// <summary>
        /// (Non-Blocking) Stop the player from moving.
        /// </summary>
        /// <returns>Returns true if we are able to stop moving.</returns>
        public static async Task MoveStop(Func<bool> conditionCheck = null)
        {
            if (conditionCheck != null && !conditionCheck())
                return;

            await CommonCoroutines.StopMoving();
        }

        /// <summary>
        /// (Non-Blocking) Attempts to face the player's current target.
        /// </summary>
        /// <returns>Returns true if we are able to safely face the target</returns>
        public static async Task FaceMyCurrentTarget()
        {
            if (Me.CurrentTarget == null)
                return;
            if ((GetAsyncKeyState(Keys.LButton) != 0
                || GetAsyncKeyState(Keys.RButton) != 0)
                || GetAsyncKeyState(moveForward) != 0
                || GetAsyncKeyState(moveBackward) != 0
                || GetAsyncKeyState(moveLeft) != 0
                || GetAsyncKeyState(moveRight) != 0
                || GetAsyncKeyState(strafeLeft) != 0
                || GetAsyncKeyState(strafeRight) != 0)
            {
                return;
            }
            await FaceTarget(Me.CurrentTarget,
                () =>
                    Me.CurrentTarget != null
                    && AllowFacing()
                    && !Me.IsMoving
                    && !Me.IsSafelyFacing(Me.CurrentTarget));
        }

        /// <summary>
        /// (Non-Blocking) Attempts to face the specified target.
        /// </summary>
        /// <returns>Returns true if we are able to safely face the target</returns>
        public static async Task FaceTarget(WoWUnit target, Func<bool> conditionCheck = null)
        {
            if (conditionCheck != null && !conditionCheck()) return;
            target.Face();
            await CommonCoroutines.SleepForLagDuration();
        }

        /// <summary>
        /// (Non-Blocking) Attempts to clear the player's current target.
        /// </summary>
        /// <returns>Returns true if we are able to clear the target</returns>
        public static async Task<bool> ClearMyDeadTarget()
        {
            if (Me.CurrentTarget != null && Me.CurrentTarget.IsDead)
            {
                Me.ClearTarget();
                await CommonCoroutines.SleepForLagDuration();
                return false;
            }
            return false;
        }
    }
}
