﻿using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HBDisc
{
    class Party
    {
        public static IEnumerable<WoWUnit> PartyMembers { get { return getPartyMembers(); } }
        public static IEnumerable<WoWUnit> Tanks { get { return getTanks(); } }

        public static bool MeIsInParty { get { return StyxWoW.Me.GroupInfo.GroupSize > 0; } }
        public static bool MeIsInProvingGrounds { get { return StyxWoW.Me.MinimapZoneText == "Proving Grounds"; } }

        public static bool PartyMembersInRange
        {
            get
            {
                var t = getPartyMembers().Where(p => p != null && p.IsAlive && p.DistanceSqr <= 40 * 40).ToList();
                return t.Count() > 0 ? true : false;
            }
        }

        public static IEnumerable<WoWPartyMember> WoWPartyMembers()
        {
            return StyxWoW.Me.GroupInfo.RaidMembers.Union(StyxWoW.Me.GroupInfo.PartyMembers).Distinct().ToList();
        }
        public static IEnumerable<WoWUnit> getPartyMembers()
        {
            if (StyxWoW.Me.MinimapZoneText == "Proving Grounds" && StyxWoW.Me.Combat)
            {
                var t = ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(p => p != null
                    && pgUnits.Contains(p.Name)).ToList();
                t.Add(StyxWoW.Me);
                return t;
            }
            else
            {
                var t = ObjectManager.GetObjectsOfTypeFast<WoWPlayer>().Where(p => p.IsInMyPartyOrRaid).ToList();
                return t;
            }
        }
        public static IEnumerable<WoWUnit> getTanks()
        {
            if (StyxWoW.Me.MinimapZoneText == "Proving Grounds")
            {
                return ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(p => p != null
                    && p.Name == "Oto the Protector");
            }
            else
            {
                var t = WoWPartyMembers().Where(p => p != null && p.HasRole(WoWPartyMember.GroupRole.Tank)).Select(p => p.ToPlayer()).ToList();
                return t;
            }
        }



        public static HashSet<string> pgUnits = new HashSet<string>
		{
			"Sooli the Survivalist",
			"Kavan the Arcanist",
			"Ki the Assassin",
			"Oto the Protector"
		};
    }
}
