﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Styx.Helpers;
using System.IO;
using Styx;
using Styx.Common;
using System.ComponentModel;
using DefaultValue = Styx.Helpers.DefaultValueAttribute;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using System.Windows.Forms;

namespace HBDisc
{
    class CRSettings : Settings
    {
        public static LocalPlayer Me { get { return StyxWoW.Me; } }
        public static readonly CRSettings myPrefs = new CRSettings();

        public string SavePath = Path.Combine(Utilities.AssemblyDirectory, string.Format(@"Routines/HBDisc/Settings/{0}_{1}_HBDiscSettings.xml", Me.RealmName, Me.Name));

        public CRSettings()
            : base(Path.Combine(Utilities.AssemblyDirectory, string.Format(@"Routines/HBDisc/Settings/{0}_{1}_HBDiscSettings.xml", Me.RealmName, Me.Name)))
        {
        }

        [Setting, DefaultValue(75)]
        public int flashHealP { get; set; }

        [Setting, DefaultValue(65)]
        public int flashHealR { get; set; }

        [Setting, DefaultValue(90)]
        public int pwsP { get; set; }

        [Setting, DefaultValue(80)]
        public int pwsR { get; set; }

        [Setting, DefaultValue(85)]
        public int penanceP { get; set; }

        [Setting, DefaultValue(85)]
        public int penanceR { get; set; }

        [Setting, DefaultValue(90)]
        public int healP { get; set; }

        [Setting, DefaultValue(90)]
        public int healR { get; set; }

        [Setting, DefaultValue(85)]
        public int pomP { get; set; }

        [Setting, DefaultValue(85)]
        public int pomR { get; set; }

        [Setting, DefaultValue(85)]
        public int pohP { get; set; }

        [Setting, DefaultValue(85)]
        public int pohR { get; set; }

        [Setting, DefaultValue(3)]
        public int pohPlayersP { get; set; }

        [Setting, DefaultValue(5)]
        public int pohPlayersR { get; set; }

        [Setting, DefaultValue(85)]
        public int cascadeP { get; set; }

        [Setting, DefaultValue(85)]
        public int cascadeR { get; set; }

        [Setting, DefaultValue(3)]
        public int cascadePlayersP { get; set; }

        [Setting, DefaultValue(5)]
        public int cascadePlayersR { get; set; }

        [Setting, DefaultValue(85)]
        public int haloP { get; set; }

        [Setting, DefaultValue(85)]
        public int haloR { get; set; }

        [Setting, DefaultValue(3)]
        public int haloPlayersP { get; set; }

        [Setting, DefaultValue(5)]
        public int haloPlayersR { get; set; }

        [Setting, DefaultValue(false)]
        public bool needAtonement { get; set; }





        [Setting, DefaultValue(45)]
        public int desperate { get; set; }

        [Setting, DefaultValue(45)]
        public int healingtonic { get; set; }

        [Setting, DefaultValue(45)]
        public int healthstone { get; set; }

        [Setting, DefaultValue(45)]
        public int naaru { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("Movement")]
        [DisplayName("Enable Facing")]
        [Description("Enable auto Facing Target")]
        public bool enableFacing { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("Movement")]
        [DisplayName("Enable Movement")]
        [Description("Enable auto movement")]
        public bool enableMovement { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("Movement")]
        [DisplayName("Enable Targeting")]
        [Description("Enable auto targeting")]
        public bool enableTargeting { get; set; }

        [Setting]
        [DefaultValue("W")]
        [Category("Movement Keys")]
        [DisplayName("Move Forward")]
        public string moveforwards { get; set; }

        [Setting]
        [DefaultValue("S")]
        [Category("Movement Keys")]
        [DisplayName("Move Backwards")]
        public string movebackward { get; set; }

        [Setting]
        [DefaultValue("A")]
        [Category("Movement Keys")]
        [DisplayName("Move Left")]
        public string moveleft { get; set; }

        [Setting]
        [DefaultValue("D")]
        [Category("Movement Keys")]
        [DisplayName("Move Right")]
        public string moveright { get; set; }

        [Setting]
        [DefaultValue("Q")]
        [Category("Movement Keys")]
        [DisplayName("Strafe Left")]
        public string strafeleft { get; set; }

        [Setting]
        [DefaultValue("E")]
        [Category("Movement Keys")]
        [DisplayName("Strafe Right")]
        public string straferight { get; set; }

        [Setting, DefaultValue("Alt")]
        public string modPauseKey { get; set; }

        [Setting, DefaultValue("P")]
        public string pauseKey { get; set; }

        [Setting, DefaultValue("Alt")]
        public string modAtonementOnKey { get; set; }

        [Setting, DefaultValue("A")]
        public string atonementOnKey { get; set; }

        [Setting, DefaultValue("Alt")]
        public string modDpsOnKey { get; set; }

        [Setting, DefaultValue("D")]
        public string dpsOnKey { get; set; }


        /* Alchemist Flask
        Crystal of Insanity
        Oralius Whispering Crystal
        None*/

        [Setting, DefaultValue(3)]
        public int buffs { get; set; }

        [Setting, DefaultValue(false)]
        public bool darkmoonFirewater { get; set; }
    }
}
