﻿using Styx;
using Styx.Common;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

namespace HBDisc
{
    class Units
    {
        public static LocalPlayer Me { get { return StyxWoW.Me; } }

        public static IEnumerable<WoWUnit> UnfriendlyUnits
        {
            get { return ObjectManager.GetObjectsOfType<WoWUnit>(true, false).Where(u => !u.IsDead && u.CanSelect && u.Attackable && !u.IsFriendly); }
        }

        public static WoWUnit dpsTarget
        {
            get
            {
                var t = ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(p => p != null
                    && p.IsAlive
                    && p.CanSelect
                    && p.Attackable
                    && p.InLineOfSight
                    && p.Combat
                    && (p.IsTargetingMeOrPet || p.IsTargetingMyPartyMember || p.IsTargetingMyRaidMember)
                    && Me.IsSafelyFacing(p)).OrderBy(p => p.Distance).FirstOrDefault();
                return t != null ? t : null;
            }
        }

        public static int addCount(WoWUnit unit, float range)
        {
            var t = ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(p => p != null
                && p.IsAlive
                && (p.IsTargetingMeOrPet || p.IsTargetingMyPartyMember || p.IsTargetingMyRaidMember)
                && p.Location.DistanceSqr(unit.Location) <= range * range
                && p.Attackable
                && p.CanSelect).ToList();
            return t.Count();
        }

        #region findTarget
        public static WoWUnit getNewTarget()
        {
            var t = ObjectManager.GetObjectsOfType<WoWUnit>().Where(u => u != null
                && u.IsAlive
                && (u.Combat
                && (u.IsTargetingMeOrPet || u.IsTargetingMyPartyMember || u.IsTargetingMyRaidMember))
                && u.CanSelect
                && u.Attackable
                && Me.IsSafelyFacing(u))
                .OrderBy(u => u.Distance).FirstOrDefault();
            return t != null ? t : null;
        }
        public static async Task<bool> FindTarget()
        {
            WoWUnit unit = getNewTarget();
            if (unit == null) return false;
            Logging.Write(Colors.CornflowerBlue, "[Find Target] new target: " + unit.SafeName);
            unit.Target();
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        #endregion

        #region MeleeAttackers
        public static List<WoWUnit> MeleeAttackers()
        {
            return ObjectManager.GetObjectsOfType<WoWUnit>().Where(u => u != null
                && u.IsAlive
                && u.IsHostile
                && (u.Combat
                && (u.IsTargetingMeOrPet || u.IsTargetingMyPartyMember || u.IsTargetingMyRaidMember))
                && u.Distance < 10).OrderBy(u => u.Distance).ToList();
        }

        public static int MeleeAttackersCount { get { return MeleeAttackers().Count(); } }

        public static async Task<bool> findMeleeAttackers(bool reqs)
        {
            if (!reqs) return false;
            WoWUnit unit = MeleeAttackers().FirstOrDefault();
            Logging.Write(Colors.CornflowerBlue, "Changing target to closest attacker " + unit.SafeName);
            unit.Target();
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        #endregion

        public static WoWUnit swpTarget
        {
            get
            {
                var t = ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(p => p != null
                    && p.IsAlive
                    && p.CanSelect
                    && p.Attackable
                    && p.InLineOfSight
                    && !Main.debuffExists(Main.ShadowWordPain, p)
                    && Me.IsSafelyFacing(p)
                    && (p.Combat
                    && (p.IsTargetingMeOrPet || p.IsTargetingMyPartyMember || p.IsTargetingMyRaidMember))).OrderBy(p => p.Distance).FirstOrDefault();
                return t != null ? t : null;
            }
        }

    }
}
